package goastro;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import com.google.gson.*;
import goastro.*;
import java.util.*;


public class transactionspostTest {
	@Test public void transactionspost() {
		API.setAuthentication("Example_API_Key","Example_Pin");
		API.local_test=true;

		//Building Response
		Map<String, Object> expected_response = new HashMap<String, Object>();
		expected_response.put("type","transaction");
		expected_response.put("key","dnfwxwhz5kvnbgb");
		expected_response.put("refnum","100061");
		expected_response.put("created","2018-12-04 10:48:44");
		expected_response.put("is_duplicate","N");
		expected_response.put("result_code","A");
		expected_response.put("result","Approved");
		expected_response.put("authcode","314407");
		expected_response.put("proc_refnum","18120443975126");
			Map<String, Object> creditcard = new HashMap<String, Object>();
			Map<String, Object> creditcard1 = new HashMap<String, Object>();
			creditcard1.put("cardholder","Minerva McGonnegall");
			creditcard1.put("number","4444xxxxxxxx1111");
			creditcard1.put("category_code","A");
			creditcard1.put("entry_mode","swiped");
			creditcard1.put("avs_street","1234 Portkey Ave");
			creditcard1.put("avs_postalcode","90006");
		expected_response.put("creditcard","creditcard");
		expected_response.put("invoice","98454685");
		expected_response.put("orderid","4556432");
			Map<String, Object> avs = new HashMap<String, Object>();
			Map<String, Object> avs2 = new HashMap<String, Object>();
			avs2.put("result_code","YYY");
			avs2.put("result","Address: Match & 5 Digit Zip: Match");
		expected_response.put("avs","avs");
			Map<String, Object> cvc = new HashMap<String, Object>();
			Map<String, Object> cvc3 = new HashMap<String, Object>();
			cvc3.put("result_code","N");
			cvc3.put("result","No Match");
		expected_response.put("cvc","cvc");
			Map<String, Object> batch = new HashMap<String, Object>();
			Map<String, Object> batch4 = new HashMap<String, Object>();
			batch4.put("type","batch");
			batch4.put("key","ft1m9m5p9wgd9mb");
			batch4.put("batchrefnum","12345678");
			batch4.put("sequence","2902");
		expected_response.put("batch","batch");
		expected_response.put("auth_amount","500.00");
		expected_response.put("trantype","Credit Card Sale");
		expected_response.put("iccdata","");
			Map<String, Object> receipts = new HashMap<String, Object>();
			Map<String, Object> receipts5 = new HashMap<String, Object>();
			receipts5.put("customer","Mail Sent Successfully");
			receipts5.put("merchant","Mail Sent Successfully");
		expected_response.put("receipts","receipts");
			Map<String, Object> customer = new HashMap<String, Object>();
			Map<String, Object> customer6 = new HashMap<String, Object>();
			customer6.put("custkey","ksddgpqgpbs5zkmb");
			customer6.put("custid","10275538");
		expected_response.put("customer","customer");
			Map<String, Object> savedcard = new HashMap<String, Object>();
			Map<String, Object> savedcard7 = new HashMap<String, Object>();
			savedcard7.put("type","Visa");
			savedcard7.put("key","tyet-xk8x-vpj4-7swq");
			savedcard7.put("cardnumber","4000xxxxxxxx2224");
		expected_response.put("savedcard","savedcard");
		String encoded_response = API.json_encode(expected_response);
		MockHandler.response = encoded_response;

		//Building Request
		Map<String, Object> reqdata = new HashMap<String, Object>();
			reqdata.put("command","sale");
			reqdata.put("invoice","98454685");
			reqdata.put("amount","50");
				Map<String, Object> amount_detail = new HashMap<String, Object>();
				amount_detail.put("subtotal","40.00");
				amount_detail.put("tax","10.00");
				amount_detail.put("enable_partialauth","false");
			reqdata.put("amount_detail","amount_detail");
				Map<String, Object> creditcard8 = new HashMap<String, Object>();
				creditcard.put("cardholder","Minerva McGonnegall");
				creditcard.put("number","4000100011112224");
				creditcard.put("expiration","1222");
			reqdata.put("creditcard","creditcard");
				Map<String, Object> check = new HashMap<String, Object>();
				check.put("accountholder","Remus Lupin");
				check.put("routing","123456789");
				check.put("account","324523524");
				check.put("account_type","checking");
			reqdata.put("check","check");
				Map<String, Object> traits = new HashMap<String, Object>();
			reqdata.put("traits","traits");
				Map<String, Object> billing_address = new HashMap<String, Object>();
				billing_address.put("company","Hogwarts School of Witchcraft and Wizardry");
				billing_address.put("street","123 Astronomy Tower");
				billing_address.put("postalcode","10005");
			reqdata.put("billing_address","billing_address");
				Map<String, Object> shipping_address = new HashMap<String, Object>();
				shipping_address.put("company","Hogwarts School of Witchcraft and Wizardry");
				shipping_address.put("street","123 Astronomy Tower");
				shipping_address.put("postalcode","10005");
			reqdata.put("shipping_address","shipping_address");
			List<Map> lineitems = new ArrayList<Map>();
				Map<String, Object> LineItem = new HashMap<String, Object>();
				LineItem.put("name","Antique Pensieve");
				LineItem.put("description","See into your past...");
				LineItem.put("size","Large");
				LineItem.put("color","Bronze");
				LineItem.put("cost","450.00");
				LineItem.put("list_price","500.00");
				LineItem.put("qty","1");
				LineItem.put("sku","68453423");
				LineItem.put("commoditycode","535");
				LineItem.put("discountamount","0");
				LineItem.put("discountrate","0");
				LineItem.put("taxable","");
				LineItem.put("taxamount","45.00");
				LineItem.put("taxclass","NA");
				LineItem.put("taxrate","10");
				LineItem.put("um","EA");
				LineItem.put("category","Antiques");
				LineItem.put("manufacturer","The Ancients");
			lineitems.add(LineItem);
				Map<String, Object> LineItem9 = new HashMap<String, Object>();
				LineItem9.put("name","Antique Pensieve");
				LineItem9.put("description","See into your past...");
				LineItem9.put("size","Large");
				LineItem9.put("color","Bronze");
				LineItem9.put("cost","450.00");
				LineItem9.put("list_price","500.00");
				LineItem9.put("qty","1");
				LineItem9.put("sku","68453423");
				LineItem9.put("commoditycode","535");
				LineItem9.put("discountamount","0");
				LineItem9.put("discountrate","0");
				LineItem9.put("taxable","");
				LineItem9.put("taxamount","45.00");
				LineItem9.put("taxclass","NA");
				LineItem9.put("taxrate","10");
				LineItem9.put("um","EA");
				LineItem9.put("category","Antiques");
				LineItem9.put("manufacturer","The Ancients");
			lineitems.add(LineItem9);
			reqdata.put("lineitems",lineitems);
			List<Map> custom_fields = new ArrayList<Map>();
			reqdata.put("custom_fields",custom_fields);
		String response = "";
		response = goastro.Transactions.post(reqdata);

		assertEquals("Response did not match ",encoded_response,response);
		assertEquals("Request did not match ",API.json_encode(reqdata),MockHandler.request);
		assertTrue("Path not formatted correctly "+MockHandler.path,MockHandler.path.contains("https://api.goastro.com/api/v2/transactions"));
		assertEquals("Method did not match ","POST",MockHandler.method.toUpperCase());
	}
}